#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <unordered_map>
#include <random>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()
#define coutd cout << fixed << setprecision(20)

using namespace std;
using ll = long long;
using ld = long double;


int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int n, m;
    ll T;
    cin >> n >> m >> T;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
    }
    vector<int> b(m);
    for (int i = 0; i < m; ++i)
    {
        cin >> b[i];
        --b[i];
    }
    // m = n
    ll ans = 0;
    for (int i = 0; i < n; ++i)
    {
        ll cur = T / a[i];
        ans = max(ans, cur);
    }
    cout << ans;

    return 0;
}
